;wlacznik swiatla - uklad regulacji mocy

#define DATA_OUT GPIO, 0		;triak
#define SYNCHRO GPIO, 1			;przejscie przez 0
#define KEY GPIO, 2			;klawisz
#define IN_CLR GPIO, 4			;potwierdzenie odbioru danych z pilo

#define dph 20h				; starszy bajt pomocniczy
#define dpl 21h				; mlodszy bajt pomocniczy
#define licznik h'22'			; pomocniczy licznik petli opoznienia
#define mem_out h'23'			; podreczna pamiec bitow
						;mem_out.80h	1<=>swiatlo na 100%
						;mem_out 0000 0001B <=> 1 poziom PWM 75%
						;mem_out 0000 0010B <=> 2 poziom PWM 50%
						;mem_out 0000 0100B <=> 3 poziom PWM 30%
						;mem_out 0000 1000B <=> 4 poziom PWM 20%
						;mem_out 0001 0000B <=> 5 poziom PWM 15%
						;mem_out 0010 0000B <=> 6 poziom PWM 10%
						;mem_out 0100 0000B <=> 7 poziom PWM  5%

	
#define up_down h'24'			;zmiana kierunku up=1 down=0
#define data_dph h'25'			;przepisanie danej z eeprom
#define data_dpl h'26'			;dane odbierane z rf
#define time_off h'27'			;czas niekiego stanu na lampach
#define stos h'29'

cod_rf equ h'ae'				;wlasciwy kod odczytywany z RF
;deklaracj typu procesora i formatu liczb
	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_OFF &_WDT_OFF; gen wew. RC bez wyjscia 
									;wlaczone wejscie reset
									;watch dog wylaczony
	org 0
	goto start

	org 4
;	goto PWM
start

;ustawienia przerwania od timera0
;ustawienia timera t0
	bsf status, rp0 ;bank1
	bcf option_reg, t0cs	; zliczanie cykil maszynowych
	bsf option_reg, psa	;preskaler dla watchdoga
	bcf intcon, t0if		;zerowanie flagi przerwania T0
	bcf intcon, t0ie		;zablokowanie przerwania
	bcf status, rp0 ;bank0
	clrf tmr0			;zerowanie rejestru licznika T0
	bcf intcon, gie	;ogolny bit zezwolenia na przerwania off

;wylacz komparator
	movlw .7
	movwf cmcon

;konfiguracja linii i/o
	bsf status, rp0;bank1

	movlw h'2e'					;0010 1110 0=wyjscie, 1=wejscie
	movwf trisio
	movlw h'3F'					;0011 1111 rezystor pull up GP5 - prog
	movwf wpu
	bcf option_reg, 7				;zalacza wybrane w wpu rezystory do Vdd
							;GPPU=0 w rej option_reg 7 bit zalacza rezustory z rej. wpu
	bcf status, rp0 ;bank0

;wylacz adc
	;wylacz ADC
	bsf status, rp0 ;bank1
	clrf ansel
	bcf status, rp0 ;bank0

	bcf intcon, gie	; zablokuj przerwania
	bsf status, rp0 ;bank1
	bsf option_reg, intedg	; 	PRZERWANIE NA ZBOCZE NARASTAJACE SYGNALU SYNCHRO
	bcf status, rp0 ;bank0
	bcf intcon, intf	; zerowanie flagi przerwania
	bsf intcon, inte	; zezwolenie na przerwanie od synchro
;********************************************************
;program glowy

;************************************************************************
	movlw h'80'		;100%
	movwf mem_out	
	clrf up_down	;kierunek w dol
loop
	bcf DATA_OUT	;WLACZ 100% MOCY	
	call delay500ms

	btfsc KEY		;oczekiwanie na nacisniecie klawisza
	goto $-1		;
	btfsc mem_out,0
	goto loop0a		;75%
	btfsc mem_out,1
	goto loop1c		;50%
	btfsc mem_out,2
	goto loop2c		;30%
	btfsc mem_out,3
	goto loop3c		;20%
	btfsc mem_out,4
	goto loop4c		;15%
	btfsc mem_out,5
	goto loop5c		;10%
	btfsc mem_out,6
	goto loop6c		;5%
loop0b
	clrf up_down	;kierunek w dol
	bsf DATA_OUT	;WLACZ 100% MOCY	
	call delay500ms


	btfss KEY
	goto loop0a		;wciaz nacisniety klawisz
	btfsc KEY		;klawisz by puszczony
	goto $-1		;czekiwanie na klawisz
	call delay500ms
	btfsc KEY		; jesli trzymamy klawisz KEY to 75%
	goto loop		;bylo krotkie nacisniecie klawisza - wyl. swiato
loop0a
	clrf licznik	;zerowanie licznika pomocniczego
	movlw h'04'		;75%
	movwf data_dph	
	movlw h'C0'		;75%
	movwf data_dpl	
	movlw h'01'		;75%
	movwf mem_out	
loop1
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,7
	goto loop1
	btfsc KEY
	goto loop1d
	btfss up_down,0
	goto loop1c		;klawisz byl wciaz trzymany przeskakuje do 50%
	goto loop0b		;100%
loop1d
	clrf licznik	;zerowanie licznika pomocniczego
	incf up_down,0
	movwf up_down	;zmienia warto up_down.0 na przeciwn 
loop1a			;byl puszczony klawisz
	call loop_pwm
	btfsc KEY
	goto loop1a		;oczekuje nacisniecie klawisza
loop1b
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,6
	goto loop1b
	btfsc KEY
	goto loop
	btfsc up_down,0	;czy kierunek w gore czy w dol 
	goto loop0b		;skocz na 100%
loop1c
	clrf licznik	;zerowanie licznika pomocniczego
	movlw h'05'		;50%
	movwf data_dph	
	movlw h'D0'		;50%
	movwf data_dpl	
	movlw h'02'		;50%
	movwf mem_out	
loop2
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,7
	goto loop2
	btfsc KEY
	goto loop2d
	btfss up_down,0
	goto loop2c		;klawisz byl wciaz trzymany przeskakuje do 30%
	goto loop0a		;75%
loop2d
	clrf licznik	;zerowanie licznika pomocniczego
	incf up_down,0
	movwf up_down	;zmienia warto up_down.0 na przeciwn !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
loop2a			;byl puszczony klawisz
	call loop_pwm
	btfsc KEY
	goto loop2a		;oczekuje nacisniecie klawisza
loop2b
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,6
	goto loop2b
	btfsc KEY
	goto loop
	btfsc up_down,0	;czy kierunek w gore czy w dol !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto loop0a		;skocz na 75%
loop2c
	clrf licznik	;zerowanie licznika pomocniczego
	movlw h'06'		;30%
	movwf data_dph	
	movlw h'D9'		;30%
	movwf data_dpl	
	movlw h'04'		;30%
	movwf mem_out	
loop3
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,7
	goto loop3
	btfsc KEY
	goto loop3d
	btfss up_down,0
	goto loop3c		;klawisz byl wciaz trzymany przeskakuje do 20%
	goto loop1c
loop3d
	clrf licznik	;zerowanie licznika pomocniczego
	incf up_down,0
	movwf up_down	;zmienia warto up_down.0 na przeciwn !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
loop3a			;byl puszczony klawisz
	call loop_pwm
	btfsc KEY
	goto loop3a		;oczekuje nacisniecie klawisza
loop3b
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,6
	goto loop3b
	btfsc KEY
	goto loop
	btfsc up_down,0	;czy kierunek w gore czy w dol !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto loop1c		;skocz na 50%
loop3c
	clrf licznik	;zerowanie licznika pomocniczego
	movlw h'06'		;20%
	movwf data_dph	
	movlw h'ED'		;20%
	movwf data_dpl	
	movlw h'08'		;20%
	movwf mem_out	
loop4
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,7
	goto loop4
	btfsc KEY
	goto loop4d
	btfss up_down,0
	goto loop4c		;klawisz byl wciaz trzymany przeskakuje do 15%
	goto loop2c
loop4d
	clrf licznik	;zerowanie licznika pomocniczego
	incf up_down,0
	movwf up_down	;zmienia warto up_down.0 na przeciwn !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
loop4a			;byl puszczony klawisz
	call loop_pwm
	btfsc KEY
	goto loop4a		;oczekuje nacisniecie klawisza
loop4b
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,6
	goto loop4b
	btfsc KEY
	goto loop
	btfsc up_down,0	;czy kierunek w gore czy w dol !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto loop2c		;skocz na 30%
loop4c
	clrf licznik	;zerowanie licznika pomocniczego
	movlw h'06'		;15%
	movwf data_dph	
	movlw h'FA'		;15%
	movwf data_dpl	
	movlw h'10'		;15%
	movwf mem_out	
loop5 
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,7
	goto loop5
	btfsc KEY
	goto loop5d
	btfss up_down,0
	goto loop5c		;klawisz byl wciaz trzymany przeskakuje do 10%
	goto loop3c		;20%
loop5d
	clrf licznik	;zerowanie licznika pomocniczego
	incf up_down,0
	movwf up_down	;zmienia warto up_down.0 na przeciwn !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
loop5a			;byl puszczony klawisz
	call loop_pwm
	btfsc KEY
	goto loop5a		;oczekuje nacisniecie klawisza
loop5b
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,6
	goto loop5b
	btfsc KEY
	goto loop
	btfsc up_down,0	;czy kierunek w gore czy w dol !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto loop3c		;skocz na 20%
loop5c
	clrf licznik	;zerowanie licznika pomocniczego
	movlw h'07'		;10%
	movwf data_dph	
	movlw h'E3'		;10%
	movwf data_dpl	
	movlw h'20'		;10%
	movwf mem_out	
loop6 	
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,7
	goto loop6
	btfsc KEY
	goto loop6d
	btfss up_down,0
	goto loop6c		;klawisz byl wciaz trzymany przeskakuje do 5%
	goto loop4c
loop6d
	clrf licznik	;zerowanie licznika pomocniczego
	incf up_down,0
	movwf up_down	;zmienia warto up_down.0 na przeciwn !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
loop6a			;byl puszczony klawisz
	call loop_pwm
	btfsc KEY
	goto loop6a		;oczekuje nacisniecie klawisza
loop6b
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,6
	goto loop6b
	btfsc KEY
	goto loop
	btfsc up_down,0	;czy kierunek w gore czy w dol !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto loop4c		;skocz na 15%
loop6c
	clrf licznik	;zerowanie licznika pomocniczego
	movlw h'07'		;5%
	movwf data_dph	
	movlw h'F6'		;5%
	movwf data_dpl	
	movlw h'40'		;5%
	movwf mem_out	
loop7
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,7
	goto loop7
	btfsc KEY
	goto loop7d
	clrf licznik	;zerowanie licznika pomocniczego
	incf up_down,0
	movwf up_down	;zmienia warto up_down.0 na przeciwn !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto loop5c		;10%
loop7d
	call loop_pwm
	btfsc KEY
	goto loop7d		;oczekuje nacisniecie klawisza
	movlw h'40'		;100%
	movwf mem_out	
	clrf up_down	;kierunek w dol
	goto loop



loop7a			;byl puszczony klawisz
	call loop_pwm
	btfsc KEY
	goto loop7a		;oczekuje nacisniecie klawisza
loop7b
	call loop_pwm
	incf licznik,0
	movwf licznik	
	btfss licznik,6
	goto loop7b
	btfsc KEY
	goto loop
	btfsc up_down,0	;czy kierunek w gore czy w dol !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto loop5c		;skocz na 10%
loop7c
	movlw h'80'		;100%
	movwf mem_out	
	clrf up_down	;kierunek w dol
	goto loop
;*************************************************************
loop_pwm
	btfss SYNCHRO
	goto $-1
	bcf DATA_OUT
	call delay
	bsf DATA_OUT
	call delay_ux100
	bcf DATA_OUT
	return
;****************************************************************************
;OPOZNIENIE 0 500ms
delay500ms
	call delay100ms
	call delay100ms
	call delay100ms
	call delay100ms
	call delay100ms
	return
;opoznienie o 100 ms
delay100ms
	movlw h'073'		;1 bylo 073
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	
delay_ux100
	movlw h'1c'		;1
delay_ux100b
	movwf dpl		;przepisuja W do dpl
	decfsz dpl,0	;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay_ux100b	;1
	return	
;opoznienie 
delay
	movf data_dph, 0		;przesya data_dph do W
delay_c
	movwf dph		;1
	movf data_dpl, 0	;1
delay_d
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay_d	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay_c	;1
	return	
;***********************************************************
	end
